#include "fetch_current_tournament.h"

FetchCurrentTournament::FetchCurrentTournament(Tournament *tourn) : tourn(tourn) {}
void FetchCurrentTournament::operator() (pqxx::transaction<> &t)
{
	pqxx::result res( t.exec("SELECT * FROM bigscreen.active_tournament NATURAL JOIN tournaments") );
	try {
		pqxx::result::tuple tournament = res.at(0);

		tourn->id = tournament["tournament"].as(tourn->id);
		tourn->name = tournament["tournamentname"].as(tourn->name);
	} catch (PGSTD::out_of_range &e) {
		tourn->id = -1;
		tourn->name = "";
	}
}
